package com.vendor.burn.consoles;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.consoles.FastbootConsole;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.ui.console.ConsolePlugin;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleFactory;
import org.eclipse.ui.console.IConsoleListener;
import org.eclipse.ui.console.IConsoleManager;
import org.eclipse.ui.internal.console.ConsoleView;
import org.vendor.console.ConsoleHelper;

public class FastbootConsoleFactory implements IConsoleFactory {
  static String BurnTool = "BurnTool";
  
  static String BurnTool_DEBUG = "BurnTool-Debug";
  
  private static FastbootConsole fConsole = new FastbootConsole(BurnTool);
  
  private static FastbootConsole debugConsole = new FastbootConsole(BurnTool_DEBUG);
  
  private static boolean fConsoleResult = false;
  
  private static boolean debugConsoleResult = false;
  
  static IConsoleManager manager = ConsolePlugin.getDefault()
    .getConsoleManager();
  
  private FastbootConsoleFactory() {
    manager.addConsoleListener((IConsoleListener)new Object(this));
  }
  
  public static FastbootConsole getDebugConsole() {
    if (!debugConsoleResult) {
      ConsoleHelper.addConsole((IConsole)debugConsole);
      debugConsoleResult = true;
    } 
    return debugConsole;
  }
  
  public static FastbootConsole getDefaultConsole() {
    if (!fConsoleResult) {
      ConsoleHelper.addConsole((IConsole)fConsole);
      fConsoleResult = true;
    } 
    return fConsole;
  }
  
  public void openConsole() {
    if (fConsole == null) {
      fConsole = createAndShowConsole(BurnTool);
    } else {
      if (manager == null)
        return; 
      manager.showConsoleView((IConsole)fConsole);
    } 
  }
  
  private FastbootConsole createAndShowConsole(String name) {
    FastbootConsole console = new FastbootConsole(name);
    ConsoleHelper.addAndShowConsole((IConsole)console);
    return console;
  }
  
  public static void clearConsole() {
    ArrayList<IConsole> toRemove = new ArrayList<>();
    if (fConsole != null)
      toRemove.add(fConsole); 
    if (debugConsole != null)
      toRemove.add(debugConsole); 
    ConsoleHelper.removeConsoles(toRemove);
    fConsole = null;
    debugConsole = null;
  }
  
  public static void displayConsole() {
    if (fConsole == null)
      getDefaultConsole(); 
    List<ConsoleView> consoleViews = ConsoleHelper.getConsoleViews();
    for (ConsoleView consoleView : consoleViews) {
      IConsole console = consoleView.getConsole();
      if (console == fConsole || console == debugConsole)
        continue; 
      if (fConsole != null)
        consoleView.display((IConsole)fConsole); 
    } 
  }
}
